
-- Offside by Dazzaa for PES2021(v0.991 27/02/21)

--audio cheat engine tutorial by nesa24
--Sider by juce


local m = {}
local last_total_offsides = 0
local last_total_foulfreekicks = 0
local total_offsides = 0
local total_foulfreekicks = 0
local last_rnd = 0
local last_rnd2 = 0


local function mute_addr()
	if mute_address then
	else
		addr1 = memory.unpack("u64", memory.read(base + 0x03AA93A8,8))
		addr2 = addr1 + 0x98
		addr3 = memory.unpack("u64", memory.read(addr2,8))
		addr4 = addr3 + 0x2e8
		addr5 = memory.unpack("u64", memory.read(addr4,8))
		addr6 = addr5 + 0x28
		addr7 = memory.unpack("u64", memory.read(addr6,8))
		addr8 = addr7 + 0x1c0
		addr9 = memory.unpack("u64", memory.read(addr8,8))
		mute_address = addr9 + 0x870
	end
end


local function shared_commentary_addr()

	addr1 = memory.unpack("u64", memory.read(base + 0x03AB7A70,8))
	addr2 = addr1 + 0x8
	shared_commentary_address = memory.unpack("u64", memory.read(addr2,8))
end


local function first_commentary_check()

	if shared_commentary_address then
		addr4 = shared_commentary_address + 0x58
		addr5 = memory.unpack("u64", memory.read(addr4,8))
		if addr5 == 0x0 then
			first_comm_id = nil	
		else
			first_comm_address = addr5 + 0x20
			first_comm_id = memory.unpack("u16", memory.read(first_comm_address, 2))
		end
	end
end


local function second_commentary_check()

	if shared_commentary_address then
		addr4 = shared_commentary_address + 0x90
		addr5 = memory.unpack("u64", memory.read(addr4,8))
		if addr5 == 0x0 then
			second_comm_id = nil	
		else
			second_comm_address = addr5 + 0x20
			second_comm_id = memory.unpack("u16", memory.read(second_comm_address, 2))
		end
	else
	end
end


local function commentary_state()

	first_commentary_check()
	second_commentary_check()
	if first_comm_id and second_comm_id then
		state = 1
	elseif first_comm_id and not second_comm_id then
		state = 2
		second_comm_id = 0

	elseif not first_comm_id and second_comm_id then
		state = 3
		first_comm_id = 0
	else
		state = 0
		first_comm_id = 0
		second_comm_id = 0
	end
	if last_state then
--		log("commentary state:"..state.."	last state: "..last_state)
	end
--	log("first commentary playing. id: "..first_comm_id)
--	log("second commentary playing. id: "..second_comm_id)
	if (first_comm_id >= 2857 and first_comm_id <= 2861) or (second_comm_id >= 2857 and second_comm_id <= 2861) then
		red_card = 1
--		log("red card")
	end
end


local function check_things()

	if offside_address and foulfreekick_address then
		total_offsides = memory.unpack("u8", memory.read(offside_address, 1))
		total_foulfreekicks = memory.unpack("u8", memory.read(foulfreekick_address, 1))
	else
		addr1 = memory.unpack("u32", memory.read(base + 0x036FBFD8,4))
		addr2 = addr1 + 0x268
		addr3 = memory.unpack("u32", memory.read(addr2,4))
		addr4 = addr3 + 0x10
		addr5 = memory.unpack("u32", memory.read(addr4,4))
		offside_address = addr5 + 0x15c
		foulfreekick_address = addr5 + 0x160
	end
end


local function mp3_rng()
    rnd = math.random (1,34)
    rnd2 = math.random (1,22)
	if rnd2 == last_rnd2 or rnd == last_rnd then
		mp3_rng()
	end
end


function m.data_ready(ctx, filename)

	if string.match(filename, "common\\menu\\general\\sideSelect.bin") then
		if mute_address then
		else
			mute_addr()
		end
	end
	if string.match(filename, "common\\demo\\fixdemoobj\\passage\\passage_%d+\\#Win\\light_config.fpkd") or string.match(filename, " common\\script\\flow\\Match\\MatchSetupRematch.json") then
--	if string.match(filename, "common\\demo\\fixdemoobj\\passage\\passage_%d+\\#Win\\light_config.fpkd") then
		shared_commentary_addr()
		check_things()

	end
	if offside_address and foulfreekick_address then
		check_things()
		if total_foulfreekicks > last_total_foulfreekicks or total_offsides > last_total_offsides then

			if total_foulfreekicks > last_total_foulfreekicks then
				log("freekick, stating commentary watch")
--				log(total_foulfreekicks..">"..last_total_foulfreekicks)
				is_a_freekick = 1
				dummy_length = 5
			else
				log("offside, stating commentary watch")
--				log(total_offsides..">"..last_total_offsides)
				is_an_offside = 1
				dummy_length= 3
			end
			dummy = audio.new(ctx.sider_dir .. "content\\audio-demo\\goal\\EPL\\dummy"..dummy_length..".mp3")
			dummy:play()
			dummy:when_done(function(ctx)
				match_screen = memory.unpack("u8", memory.read(match_screen_address, 1))
--				log(match_screen)
				end)
			mp3_rng()
			new_commentary1 = audio.new(ctx.sider_dir .. "content\\audio-demo\\goal\\EPL\\offsides\\"..rnd..".mp3")
			new_commentary2 = audio.new(ctx.sider_dir .. "content\\audio-demo\\goal\\EPL\\fouls\\"..rnd2..".mp3")
			played_once = 0
		end
	end
	if match_screen == 0 or unmute_commentary == 0 then
		if match_screen then
--			log("match screen: "..match_screen)
		end
		commentary_state()
		if is_a_freekick == 1 then
			is_a_freekick = nil
			new_commentary = new_commentary2
		elseif is_an_offside == 1 then
			is_an_offside = nil
			new_commentary = new_commentary1
		end
		if red_card == 1 then
			red_card = 0
			match_screen = nil
		else
--			log("matchscreen check...")
			if unmute_commentary == 0 and state == 2 then
				if first_comm_id ~= last_first_comm_id then
					memory.write(mute_address, "\x00\x00\x80\x3f")
					match_screen = nil
--					new_commentary = nil
					unmute_commentary = 1
					log("unmuted commentary")
					log("commentary watch disabled")
				end
			elseif last_state == 1 and state == 3 then
				if unmute_commentary == 0 then
				else				
					if played_once == 0 then
						played_once = 1
						memory.write(mute_address, "\x00\x00\x00\x00")
						if new_commentary then
							new_commentary:set_volume(0.9)
							new_commentary:play()
							new_commentary:when_done(function(ctx)
								unmute_commentary = 0
								log("waiting for state 0 to unmute")
								end)
						end
					end
				end
			elseif last_state == 0 and state == 0 then
				if unmute_commentary == 0 then
					memory.write(mute_address, "\x00\x00\x80\x3f")
					match_screen = nil
--					new_commentary = nil
					unmute_commentary = 1
					log("unmuted commentary")
					log("commentary watch disabled")
				else
					if played_once == 0 then
						played_once = 1
						memory.write(mute_address, "\x00\x00\x00\x00")
						if new_commentary then
							new_commentary:set_volume(0.9)
							new_commentary:play()
							new_commentary:when_done(function(ctx)
								unmute_commentary = 0
								log("waiting for state 0 to unmute")
								end)
						end
					end
				end
			else
				match_screen = memory.unpack("u8", memory.read(match_screen_address, 1))				
			end
		end
	elseif match_screen == 1 then
		match_screen = nil
--		new_commentary = nil
		log("commentary watch disabled")
	end
	last_state = state
	last_rnd = rnd
	last_rnd2 = rnd2
	last_total_offsides = total_offsides
	last_total_foulfreekicks = total_foulfreekicks
	last_first_comm_id = first_comm_id
	if string.match(filename, "common\\script\\flow\\Match\\MatchDiscontinue.json") or string.match(filename, "common\\script\\flow\\Match\\MatchEnd.json") then
		log("stopping offside mod")		
		match_screen = nil
		shared_commentary_address = nil
		first_comm_address = nil
		second_comm_address = nil
		offside_address = nil
		foulfreekick_address = nil
		total_offsides = 0
		total_foulfreekicks = 0
	end
end
		
function m.init(ctx)
	ctx.register("livecpk_data_ready", m.data_ready)
	base = memory.get_process_info().base
	match_screen_address = base + 0x370CAC1
end

return m
